<?php
        # Mantis - a php based bugtracking system
        # Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
        # Copyright (C) 2002 - 2004  Mantis Team   - mantisbt-dev@lists.sourceforge.net
        # This program is distributed under the terms and conditions of the GPL
        # See the README and LICENSE files for details

        # --------------------------------------------------------
        # $Id: $
        # --------------------------------------------------------

	require_once( 'core.php' );

	# ----------
	# This function return false if the bug is an excepted bug or if the user is an excepted user
	function bug_ok_to_send( $p_user_id, $p_bug_id ) {
		$t_excepted_bug_list = config_get( 'excepted_bug' );
		foreach( $t_excepted_bug_list as $t_bug_id ) {
			if ( $t_bug_id == $p_bug_id ) {
				return false;
			}
		}
		$t_date_array = getdate();
		$t_date_array['week'] = date( "W" );
                $t_excepted_user = config_get( 'excepted_user' );
                while( list( $key, $t_user_temp ) = each( $t_excepted_user ) ) {
                        foreach( $t_user_temp as $t_field => $t_field_array ) {
                                $t_username = user_get_field( $p_user_id, 'username' );
                                if( $t_field == $t_username ) {
                                        $t_result = true;
                                        foreach( $t_field_array as $t_date_field => $t_field_value ) {
                                                if( $t_field_value != $t_date_array[$t_date_field] ) {
                                                        $t_result = false;
                                                }
                                        }
                                        if( $t_result ) {
                                                return false;
                                        }
                                }
                        }
                }
                return true;
	}

	# ----------
	# This function returns true if the remainder can be send today (ie: if today is not in the excepted dates)
	function date_ok_to_send( $p_user_id, $p_bug_id ) {
		$t_excepted_bug_list = config_get( 'excepted_bug' );
		foreach( $t_excepted_bug_list as $t_bug_id ) {
			if ( $t_bug_id == $p_bug_id ) {
				return false;
			}
		}
		$t_date_array = getdate();
		$t_date_array['week'] = date( "W" );
		$t_excepted_date = config_get( 'excepted_date' );
		while( list( $key, $t_date_temp ) = each( $t_excepted_date ) ) {
			foreach( $t_date_temp as $t_date ) {
				$t_result = true;
                		foreach( $t_date as $t_field => $t_field_value ) {
                       			if( $t_field_value != $t_date_array[$t_field] ) {
						$t_result = false;
					}
				}
				if( $t_result ) {
					print "  --> Holidays or Week-end !!\n";
					return false;
				}
			}
		}
		$t_excepted_user = config_get( 'excepted_user' );
		while( list( $key, $t_user_temp ) = each( $t_excepted_user ) ) {
			foreach( $t_user_temp as $t_field => $t_field_array ) {
				$t_username = user_get_field( $p_user_id, 'username' );
				if( $t_field == $t_username ) {
					$t_result = true;
                                	foreach( $t_field_array as $t_date_field => $t_field_value ) {
                                        	if( $t_field_value != $t_date_array[$t_date_field] ) {
                                                	$t_result = false;
                                        	}
                                	}
                                	if( $t_result ) {
						print " --> Holidays or Week-end !!\n";
                                        	return false;
                                	}
				}
			}
		}
		return true;
	}

	# ----------
	# This function returns the number of day between the new_date and the old_date
	function diff_date( $p_new_date, $p_old_date) {
		$t_year_format = 'Y';
		$t_day_of_year_format = 'z';

		$t_new_year = date( $t_year_format, $p_new_date);
		$t_old_year = date( $t_year_format, $p_old_date);

		if($t_new_year != $t_old_year) {
			$t_new_day_of_year = date( $t_day_of_year_format, $p_new_date);
                        $t_old_day_of_year = date( $t_day_of_year_format, $p_old_date);
			$t_result = 365 - $t_old_day_of_year + $t_new_day_of_year;
			$t_result = $t_result + 365 * ($t_new_year - $t_old_year - 1);
		} else {
			$t_new_day_of_year = date( $t_day_of_year_format, $p_new_date);
			$t_old_day_of_year = date( $t_day_of_year_format, $p_old_date);
			$t_result = $t_new_day_of_year - $t_old_day_of_year;
		}

		return $t_result;
	}

	# ----------
        # This function returns the date of the assign operation
	function bug_get_assign_date( $p_bug_id ) {
		$t_bug_history_table = config_get( 'mantis_bug_history_table' );
		$t_bug_table = config_get( 'mantis_bug_table' );
		$query = "SELECT date_modified
	        	        FROM $t_bug_history_table
        	        	WHERE field_name='handler_id' AND
				bug_id=$p_bug_id ORDER BY date_modified DESC";
        	$result = db_query( $query );
		if ( db_num_rows( $result ) == 0 ) {
			$query = "SELECT date_submitted
				FROM $t_bug_table
				WHERE id=$p_bug_id";
			$result = db_query( $query );
			$row = db_fetch_array( $result );
			return $row['date_submitted'];
		} else {
			$row = db_fetch_array( $result );
        		return $row['date_modified'];
		}
	}

	# ----------
        # This function constructs the body email message according to the bug_id
        function email_build_bug_info( $p_bug_id, $p_user_id ) {
                # grab the project name
                $p_project_name = project_get_field( bug_get_field( $p_bug_id, 'project_id' ), 'name' );

                # grab the subject (summary)
                $p_subject = bug_get_field( $p_bug_id, 'summary' );

		$t_assign_date = bug_get_assign_date( $p_bug_id );

                # padd the bug id with zeros
                $t_bug_id = bug_format_id( $p_bug_id );

		$t_date_format = config_get( 'normal_date_format' );

		$t_now_time = time();
                $t_result = diff_date( $t_now_time, db_unixtimestamp( $t_assign_date ) );

		$t_message = '['.$p_project_name.' '.$t_bug_id.']: '.$p_subject."\n";
		$t_message .= "  ".lang_get( 'reminder_assign_date' ).": ".date($t_date_format, db_unixtimestamp( $t_assign_date ) )." ("
				.$t_result." ".lang_get( 'reminder_days' ).")\n";
		$t_message .= "  ".lang_get( 'reminder_more_info' ).": #".$t_bug_id;

		$t_message .= " \n\n";

		if( $t_result == config_get( 'first_remind' ) && bug_ok_to_send( $p_user_id, $p_bug_id ) ) {
			return $t_message;
		} else {
			if( $t_result >= config_get( 'second_remind' ) && date_ok_to_send( $p_user_id, $p_bug_id ) ) {
				return $t_message;
			} else {
	                	return '';
			}
		}
        }

        # ----------
        # This function constructs the body email message according to the bug_id
        function email_build_bug_info_assign( $p_bug_id, $p_user_id ) {
                # grab the project name
                $p_project_name = project_get_field( bug_get_field( $p_bug_id, 'project_id' ), 'name' );

                # grab the subject (summary)
                $p_subject = bug_get_field( $p_bug_id, 'summary' );

                $t_submit_date = bug_get_field( $p_bug_id, 'date_submitted' );		

                # padd the bug id with zeros
                $t_bug_id = bug_format_id( $p_bug_id );

                $t_date_format = config_get( 'normal_date_format' );

		$t_now_time = time();
                $t_result = diff_date( $t_now_time, $t_submit_date );

                $t_message = '['.$p_project_name.' '.$t_bug_id.']: '.$p_subject."\n";
                $t_message .= "  ".lang_get( 'reminder_creation_date' ).": ".date ( $t_date_format, $t_submit_date )." ("
                                .$t_result." ".lang_get( 'reminder_days' ).")\n";
                $t_message .= "  ".lang_get( 'reminder_more_info' ).": #".$t_bug_id;

                $t_message .= " \n\n";

                if( $t_result == config_get( 'first_assign_remind' ) && bug_ok_to_send( $p_user_id, $p_bug_id ) ) {
                        return $t_message;
                } else {
                        if( $t_result >= config_get( 'second_assign_remind' ) && date_ok_to_send( $p_user_id, $p_bug_id ) ) {
                                return $t_message;
                        } else {
                                return '';
                        }
                }
        }


	# ----------
        # This function returns the complete email body
        function user_get_assigned_bug( $p_user_id, $p_project_id=ALL_PROJECTS ) {
                $c_user_id      = db_prepare_int($p_user_id);
                $c_project_id   = db_prepare_int($p_project_id);

                $t_bug_table    = config_get('mantis_bug_table');

                if ( ALL_PROJECTS == $p_project_id ) {
                        $t_where_prj = '';
                } else {
                        $t_where_prj = "project_id='$c_project_id' AND";
                }

                $t_resolved     = RESOLVED;
                $t_closed       = CLOSED;

                $query = "SELECT id
                                  FROM $t_bug_table
                                  WHERE $t_where_prj
                                                status<>'$t_resolved' AND status<>'$t_closed' AND
                                                handler_id='$c_user_id'";
                $result = db_query( $query );

                $t_bug_number = db_num_rows( $result );
		$t_message = '';
		print " ($t_bug_number)\n";
		for($i=0;$i<$t_bug_number;$i++) {
			$row = db_fetch_array( $result );
			$t_message .= email_build_bug_info( $row['id'], $p_user_id );
		}

		return $t_message;
        }

	# ----------
        # This function returns the complete email body
	function user_get_not_assigned_bug( $p_project_id, $p_user_id ) {
		if ( project_get_local_user_access_level( $p_project_id, $p_user_id ) != MANAGER ) {
			echo "\n";
			return '';
		}

		$c_project_id   = db_prepare_int($p_project_id);

                $t_bug_table    = config_get( 'mantis_bug_table' );

                if ( ALL_PROJECTS == $p_project_id ) {
                        $t_where_prj = '';
                } else {
                        $t_where_prj = "project_id='$c_project_id' AND";
                }

                $t_assign     = ASSIGNED;

                $query = "SELECT id
                                  FROM $t_bug_table
                                  WHERE $t_where_prj
                                                status<'$t_assign' AND handler_id='0'";
                $result = db_query( $query );

                $t_bug_number = db_num_rows( $result );
                $t_message = '';
		print " ($t_bug_number)\n";
                for($i=0;$i<$t_bug_number;$i++) {
                        $row = db_fetch_array( $result );
                        $t_message .= email_build_bug_info_assign( $row['id'], $p_user_id );
                }


		return $t_message;
	}


	$t_user_table = config_get( 'mantis_user_table' );
	$t_project_table = config_get( 'mantis_project_table' );
	$t_email_separator1 = config_get( 'email_separator1' );
	$t_reminder_enable = config_get( 'reminder_enable' );
	$t_email_debug = config_get( 'reminder_email_debug' );
        $t_email_debug_address = config_get( 'reminder_email_debug_address' );

	if( $t_reminder_enable == OFF) {
		exit;
	}

	$query = "SELECT realname, email, id
                FROM $t_user_table WHERE enabled='1'
                ORDER BY username";
        $result = db_query( $query );
	$user_count = db_num_rows( $result );

	print "Not resolved bugs: \n\n";

	for ($i=0;$i<$user_count;$i++) {
        	$row = db_fetch_array( $result );
		lang_push( user_pref_get_language( $row['id'] ) );
		echo $row['realname'];
		$t_message = user_get_assigned_bug( $row['id'] );
		if( $t_message != '') {
			$t_mess = lang_get( 'reminder_head_message1' );
			$t_mess .=  " \n " . lang_get( 'reminder_head_message2' ) . " \n ";
	                $t_mess .= $t_email_separator1 . "\n\n" . $t_message;
			$t_message = string_email_links( $t_mess );
			$t_subject = '[BugTracking] '.lang_get( 'reminder_subject' );
			if ( $t_email_debug == ON ) {
				$t_send_email = $t_email_debug_address;
			} else {
				$t_send_email = $row['email'];
			}
			$t_email_send = email_send( $t_send_email , $t_subject, $t_message);
			if( $t_email_send ) {
				print "\n\t- Email successfully sent to: ";
				echo $row['realname'] . ' (' . $row['email'] . ')';
				print "\n\n";
			} else {
				print "\n\t* Email not sent to: ";
				echo $row['realname'] . ' (' . $row['email'] . ')';
				print "\n\n";
			}
		}
		lang_pop();
        }

	print "End of not resolved bugs.\n\n";
	
	$query = "SELECT id
			FROM $t_project_table";
	$result = db_query( $query );
	$project_count = db_num_rows( $result );

	print "Not assigned bugs: \n\n";

	for ($i=0;$i<$project_count;$i++) {
		$row = db_fetch_array( $result );
		if ( $row['id'] != 0 ) {
			$user_id_row = project_get_all_user_rows( $row['id'], MANAGER );
			$t_message = '';
			foreach ( $user_id_row as $t_user ) {
                        	$t_user_id = $t_user['id'];
				echo $t_user['realname'];
				$t_user_email = user_get_field( $t_user_id, 'email' );
				lang_push( user_pref_get_language( $t_user_id ) );
				$t_message = user_get_not_assigned_bug( $row['id'], $t_user_id );
				if( $t_message != '' ) {
					$t_mess = lang_get( 'reminder_assign_head_message1' );
                        		$t_mess .=  " \n ";
                        		$t_mess .= $t_email_separator1 . "\n\n" . $t_message;
                        		$t_message = string_email_links( $t_mess );
                        		$t_subject = '[BugTracking] '.lang_get( 'reminder_assign_subject' );
                        		if ( $t_email_debug == ON ) {
						$t_send_email = $t_email_debug_address;
					} else {
						$t_send_email = $t_user_email;
					}
					$t_email_send = email_send( $t_send_email , $t_subject, $t_message);
                        		if( $t_email_send ) {
                                		print "\n\t- Email successfully sent to: ";
                                		echo $t_user['realname'] . ' (' . $t_user_email . ')';
                                		print "\n\n";
                        		} else {
                                		print "\n\t* Email not sent to: ";
                                		echo $t_user['realname'] . ' (' . $t_user_email . ')';
                                		print "\n\n";
                        		}
				}
				lang_pop();
                     	}
                }
	}

	print "End of not assigned bugs.\n\n";

?>
